SystemOrganization addCategory: #Objetos3SelfModification!
SystemOrganization addCategory: #'Objetos3SelfModification-Tests'!

Object subclass: #ClassDiff
	instanceVariableNames: 'class1 class2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification'!

!ClassDiff class methodsFor: 'as yet unclassified' stamp: 'Sawady 11/6/2012 19:33'!
new

^ self shouldNotImplement! !

!ClassDiff class methodsFor: 'as yet unclassified' stamp: 'Sawady 11/6/2012 19:32'!
newWith: class1 and: class2

^ super new initializeWith: class1 and: class2.! !

!ClassDiff methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:06'!
class1
	^ class1! !

!ClassDiff methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:06'!
class1: anObject
	class1 := anObject! !

!ClassDiff methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:06'!
class2
	^ class2! !

!ClassDiff methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:06'!
class2: anObject
	class2 := anObject! !

!ClassDiff methodsFor: 'helpers' stamp: 'Sawady 11/6/2012 20:42'!
createCommonSuperClass: newClassName

! !

!ClassDiff methodsFor: 'helpers' stamp: 'Sawady 11/6/2012 17:42'!
getMethodDiffBetweenClasses
| methodDictDiff methodDictClass1 methodDictClass2 |

methodDictDiff := Dictionary new.

methodDictClass1 := class1 methodDictionary collect: [:i | i getSource ].
methodDictClass2 := class2  methodDictionary collect: [:i | i getSource ].

(methodDictClass1 associations intersection: methodDictClass2 associations) do: [:x | methodDictDiff add: x ].

^ methodDictDiff.
! !

!ClassDiff methodsFor: 'helpers' stamp: 'Sawady 11/6/2012 17:43'!
getVarDiffBetweenClasses

^ class1 instVarNames intersection: class2 instVarNames.! !

!ClassDiff methodsFor: 'initialize-release' stamp: 'Sawady 11/6/2012 19:36'!
initializeWith: aClass and: anotherClass

class1 := aClass.
class2 := anotherClass.! !

!ClassDiff methodsFor: 'public interface' stamp: 'Sawady 11/6/2012 20:10'!
makeDiff: newClassName

| commonSuperClass |

self validateSameParentClass.

self createCommonSuperClass: newClassName.

commonSuperClass := RBClass named: newClassName asSymbol.
	
self pullUpMethods: commonSuperClass.

self pullUpVars: commonSuperClass.! !

!ClassDiff methodsFor: 'helpers' stamp: 'Sawady 11/6/2012 20:08'!
pullUpMethods: newRBClass
| selectorsToRemove |

selectorsToRemove := self getMethodDiffBetweenClasses keys.

(RBPullUpMethodRefactoring pullUp: selectorsToRemove from: class1) execute.

(RBRemoveMethodRefactoring removeMethods: selectorsToRemove from: class2) execute.! !

!ClassDiff methodsFor: 'helpers' stamp: 'Sawady 11/6/2012 20:12'!
pullUpVars: newRBClass

self getVarDiffBetweenClasses do: [ :v | 
      (RBPullUpInstanceVariableRefactoring variable: v class: class1) execute.
	(RBRemoveInstanceVariableRefactoring variable: v class: class2) execute.
]! !

!ClassDiff methodsFor: 'validation' stamp: 'Sawady 11/6/2012 18:02'!
validateSameParentClass

(class1 superclass = class2 superclass) ifFalse: [ 
	Exception new signal: 'The two classes must have the same parent class' 
].! !

Object subclass: #CreateCommonSuperClass
	instanceVariableNames: 'superClassName superClassCreated class1 class2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification'!

!CreateCommonSuperClass class methodsFor: 'as yet unclassified' stamp: 'Sawady 11/6/2012 20:48'!
commonSuperClass: aNewClassName class1: aClass1 class2: aClass2

^ super new initializeSuperClass: aNewClassName class1: aClass1 class2: aClass2.
! !

!CreateCommonSuperClass methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 20:56'!
class1
	^ class1! !

!CreateCommonSuperClass methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 20:56'!
class1: anObject
	class1 := anObject! !

!CreateCommonSuperClass methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 20:56'!
class2
	^ class2! !

!CreateCommonSuperClass methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 20:56'!
class2: anObject
	class2 := anObject! !

!CreateCommonSuperClass methodsFor: 'execution' stamp: 'Sawady 11/6/2012 21:34'!
execute

self superClassCreated: (class1 superclass subclass: self superClassName asSymbol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: Example1 category asString).
	
self class1 superclass: self superClassCreated.

self class2 superclass: self superClassCreated.

! !

!CreateCommonSuperClass methodsFor: 'initialize-release' stamp: 'Sawady 11/6/2012 21:11'!
initializeSuperClass: aNewClassName class1: aClass1 class2: aClass2

superClassName := aNewClassName.

class1 := aClass1.

class2 := aClass2.! !

!CreateCommonSuperClass methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 21:11'!
superClassCreated
	^ superClassCreated! !

!CreateCommonSuperClass methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 21:11'!
superClassCreated: anObject
	superClassCreated := anObject! !

!CreateCommonSuperClass methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 20:56'!
superClassName
	^ superClassName! !

!CreateCommonSuperClass methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 20:56'!
superClassName: anObject
	superClassName := anObject! !

!CreateCommonSuperClass methodsFor: 'execution' stamp: 'Sawady 11/6/2012 21:38'!
undo
| superClassToDelete |

self class1 superclass: self superClassCreated superclass.
self class2 superclass: self superClassCreated superclass.

superClassToDelete := self superClassCreated.
self superClassCreated: nil.

superClassToDelete removeFromSystem.! !

Object subclass: #Example1
	instanceVariableNames: 'v1 v2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification-Tests'!

!Example1 methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 14:14'!
m1
^'m1'! !

!Example1 methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 14:12'!
m2
^'m2'! !

Object subclass: #Example2
	instanceVariableNames: 'v1 v3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification-Tests'!

!Example2 methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 14:12'!
m1
^'m1'! !

!Example2 methodsFor: 'as yet unclassified' stamp: 'jh 10/23/2012 14:12'!
m3
^'m3'! !

Object subclass: #PullUpDiffMethods
	instanceVariableNames: 'class1 class2 oldMethods1 oldMethods2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification'!

!PullUpDiffMethods class methodsFor: 'as yet unclassified' stamp: 'Sawady 11/6/2012 20:51'!
class1: aClass1 class2: aClass2

^ super new initializeClass1: aClass1 class2: aClass2.! !

!PullUpDiffMethods methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 20:56'!
class1
	^ class1! !

!PullUpDiffMethods methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 20:56'!
class1: anObject
	class1 := anObject! !

!PullUpDiffMethods methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 20:56'!
class2
	^ class2! !

!PullUpDiffMethods methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 20:56'!
class2: anObject
	class2 := anObject! !

!PullUpDiffMethods methodsFor: 'execution' stamp: 'Sawady 11/6/2012 20:49'!
execute! !

!PullUpDiffMethods methodsFor: 'initialize-release' stamp: 'Sawady 11/6/2012 20:51'!
initializeClass1: aClass1 class2: aClass2

class1 := aClass1.

class2 := aClass2.! !

!PullUpDiffMethods methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 21:10'!
oldMethods1
	^ oldMethods1! !

!PullUpDiffMethods methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 21:10'!
oldMethods1: anObject
	oldMethods1 := anObject! !

!PullUpDiffMethods methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 21:10'!
oldMethods2
	^ oldMethods2! !

!PullUpDiffMethods methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 21:10'!
oldMethods2: anObject
	oldMethods2 := anObject! !

!PullUpDiffMethods methodsFor: 'initialize-release' stamp: 'Sawady 11/6/2012 21:08'!
saveContext! !

!PullUpDiffMethods methodsFor: 'execution' stamp: 'Sawady 11/6/2012 21:06'!
undo! !

Object subclass: #PullUpDiffVars
	instanceVariableNames: 'class1 class2 oldVars1 oldVars2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification'!

!PullUpDiffVars methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 20:56'!
class1
	^ class1! !

!PullUpDiffVars methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 20:56'!
class1: anObject
	class1 := anObject! !

!PullUpDiffVars methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 20:56'!
class2
	^ class2! !

!PullUpDiffVars methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 20:56'!
class2: anObject
	class2 := anObject! !

!PullUpDiffVars methodsFor: 'execution' stamp: 'Sawady 11/6/2012 20:49'!
execute! !

!PullUpDiffVars methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 21:10'!
oldVars1
	^ oldVars1! !

!PullUpDiffVars methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 21:10'!
oldVars1: anObject
	oldVars1 := anObject! !

!PullUpDiffVars methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 21:10'!
oldVars2
	^ oldVars2! !

!PullUpDiffVars methodsFor: 'accessing' stamp: 'Sawady 11/6/2012 21:10'!
oldVars2: anObject
	oldVars2 := anObject! !

!PullUpDiffVars methodsFor: 'initialize-release' stamp: 'Sawady 11/6/2012 21:04'!
saveContext! !

!PullUpDiffVars methodsFor: 'execution' stamp: 'Sawady 11/6/2012 21:06'!
undo! !

TestCase subclass: #ClassDiffTest
	instanceVariableNames: 'classDiff'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Objetos3SelfModification-Tests'!

!ClassDiffTest methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:08'!
classDiff
	^ classDiff! !

!ClassDiffTest methodsFor: 'accessing' stamp: 'Sawady 10/27/2012 08:08'!
classDiff: anObject
	classDiff := anObject! !

!ClassDiffTest methodsFor: 'tests' stamp: 'Sawady 10/27/2012 08:06'!
setUp

classDiff := ClassDiff new.
classDiff class1: Example1.
classDiff class2: Example2.! !

!ClassDiffTest methodsFor: 'tests' stamp: 'Sawady 11/1/2012 23:32'!
testGetMethodDiffBetweenClasses
	"Tests ClassDiff>>#getMethodDiffBetweenClasses"
	| methodDict |
	methodDict := self classDiff getMethodDiffBetweenClasses.

	self assert: ( methodDict size = 1).
	self assert: ( methodDict keys includesAllOf: (Set with: #m1)).! !

!ClassDiffTest methodsFor: 'tests' stamp: 'Sawady 11/1/2012 23:35'!
testGetVarDiffBetweenClasses
	"Tests ClassDiffs>>#getVarDiffBetweenClasses"
	| varDiff |
	varDiff := self classDiff getVarDiffBetweenClasses.
	self assert: varDiff size = 1.
	self assert: (varDiff includesAllOf: (Set with: 'v1'))! !
